USE [NEBIMV3]
GO

/****** Object:  StoredProcedure [dbo].[sp_PriceAndInventory_ADT]    Script Date: 31.05.2024 08:52:11 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[sp_PriceAndInventory_ADT]
    (
    @LastUpdatedDate Datetime 
	   
       )
AS Select * from (
   SELECT Price1 = Isnull(ItemBasePrice.PurchasePrice ,SPACE(0))

		, Price2 = COALESCE(ProductValidPrices_ColorPSF.Price, ProductValidPrices_ProductPSF.Price, ItembasePrice.RetailSalePrice ,0) --Satış Fiyatı

		, Price3 = COALESCE(ProductValidPrices_ColorISF.Price, ProductValidPrices_ProductISF.Price, 0) --İndirimli Fiyat



		, InventoryQty = ISNULL((SELECT	SUM(InventoryQty1)
											FROM	ItemInventory AS Warehouse1Inv WITH ( NOLOCK )
                                            WHERE	Warehouse1Inv.ItemTypeCode = prItemVariant.ItemTypeCode
                                           			AND Warehouse1Inv.ItemCode = prItemVariant.ItemCode
                                           			AND Warehouse1Inv.ColorCode = prItemVariant.ColorCode
                                           			AND Warehouse1Inv.ItemDim1Code = prItemVariant.ItemDim1Code
                                           			AND Warehouse1Inv.WarehouseCode IN( 'D1','M1','M2','M3')),0)
								  -  ISNULL((SELECT SUM(RemainingOrderQty1)
											FROM  OrderStatus() 
											WHERE OrderStatus.ItemTypeCode = prItemVariant.ItemTypeCode
											      AND OrderStatus.ItemCode = prItemVariant.ItemCode
												  AND OrderStatus.ColorCode = prItemVariant.ColorCode
												  AND OrderStatus.ItemDim1Code = prItemVariant.ItemDim1Code
												  AND OrderStatus.WarehouseCode IN('D1', 'M1','M2','M3')),0)


		  , Barcode = ISNULL(( SELECT	MAX(Barcode)
							   FROM		prItemBarcode WITH ( NOLOCK )
							   WHERE	prItemBarcode.BarcodeTypeCode IN ('B','Def')
										AND prItemBarcode.ItemTypeCode = prItemVariant.ItemTypeCode
										AND prItemBarcode.ItemCode = prItemVariant.ItemCode
										AND prItemBarcode.ColorCode = prItemVariant.ColorCode
										AND prItemBarcode.ItemDim1Code = prItemVariant.ItemDim1Code
							 ), SPACE(0))


		 ,LastUpdatedDate =   convert(varchar, LastUpdatedDate_ADT.LastUpdatedDate, 120)

	FROM	cdItem WITH ( NOLOCK )
			LEFT OUTER JOIN prItemVariant WITH ( NOLOCK ) ON prItemVariant.ItemTypeCode = cdItem.ItemTypeCode
														AND prItemVariant.ItemCode = cdItem.ItemCode

	LEFT OUTER JOIN ItemBasePrice ('TR')  ON ItemBasePrice.ItemTypeCode = cdItem.ItemTypeCode AND ItemBasePrice.ItemCode = cdItem.ItemCode
	LEFT OUTER JOIN LastUpdatedDate_ADT ON LastUpdatedDate_ADT.ItemCode = cdItem.ItemCode
												
--FİYAT 1 İÇİN (SATIŞ FİYATI)	
	LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W1'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.ItemDim2Code		= ProductValidPrices.ItemDim2Code
																			AND LastPrice.ItemDim3Code		= ProductValidPrices.ItemDim3Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
																			
							AND 	ProductValidPrices.ColorCode = SPACE(0)	
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_productPSF
			ON ProductValidPrices_productPSF.PriceGroupCode		= 'W1'
				AND ProductValidPrices_productPSF.ItemTypeCode		= cdItem.ItemTypeCode
				AND ProductValidPrices_productPSF.ItemCode			= cdItem.ItemCode
		
		LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W1'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)													
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_ColorPSF
			ON ProductValidPrices_ColorPSF.PriceGroupCode				= 'W1'
				AND ProductValidPrices_ColorPSF.ItemTypeCode			= prItemVariant.ItemTypeCode
				AND ProductValidPrices_ColorPSF.ItemCode				= prItemVariant.ItemCode				
				AND ProductValidPrices_ColorPSF.ColorCode				= prItemVariant.ColorCode
----FİYAT 1 İÇİN (SATIŞ FİYATI)	BİTİŞ		

--FİYAT 2 İÇİN (İNDİRİMLİ FİYATI) 
	LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W2'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.ItemDim2Code		= ProductValidPrices.ItemDim2Code
																			AND LastPrice.ItemDim3Code		= ProductValidPrices.ItemDim3Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
																			
							AND 	ProductValidPrices.ColorCode = SPACE(0)	
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_productISF
			ON ProductValidPrices_productISF.PriceGroupCode		= 'W2'
				AND ProductValidPrices_productISF.ItemTypeCode		= cdItem.ItemTypeCode
				AND ProductValidPrices_productISF.ItemCode			= cdItem.ItemCode
		
		LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W2'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)													
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_ColorISF
			ON ProductValidPrices_ColorISF.PriceGroupCode				= 'W2'
				AND ProductValidPrices_ColorISF.ItemTypeCode			= prItemVariant.ItemTypeCode
				AND ProductValidPrices_ColorISF.ItemCode				= prItemVariant.ItemCode				
				AND ProductValidPrices_ColorISF.ColorCode				= prItemVariant.ColorCode
----FİYAT 2 İÇİN (İNDİRİMLİ FİYATI)	BİTİŞ	
	
	WHERE	cdItem.ItemTypeCode = 1
			AND cdItem.ItemCode <> SPACE(0)
			AND cdItem.IsBlocked = 0
			AND cdItem.UseInternet = 1
			AND cdItem.UseStore = 1
			AND LastUpdatedDate_ADT.LastUpdatedDate >=@LastUpdatedDate
			) AS DATA
			WHERE DATA.Barcode<> SPACE(0)
			


			
			
GO

