USE [NEBIMV3]
GO

/****** Object:  StoredProcedure [dbo].[sp_ProductPriceAndInventoryNew_ADT]    Script Date: 31.05.2024 08:53:09 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[sp_ProductPriceAndInventoryNew_ADT]
    (
    @CreatedDate Datetime 
	   
       )
AS
   SELECT	ProductCode = cdItem.ItemCode
		  , ProductDescription = ISNULL(( SELECT	ItemDescription
										  FROM		cdItemDesc WITH ( NOLOCK )
										  WHERE		cdItemDesc.ItemTypeCode = cdItem.ItemTypeCode
													AND cdItemDesc.ItemCode = cdItem.ItemCode
													AND cdItemDesc.LangCode = 'TR'
										), SPACE(0))
		  , ColorCode =  ISNULL(prItemVariant.ColorCode,SPACE(0))
		  , ColorDescription = ISNULL(( SELECT	ColorDescription
										FROM	cdColorDesc
										WHERE	ColorCode = prItemVariant.ColorCode
												AND LangCode = 'TR'
									  ), SPACE(0))
		, ItemDimTypeCode = ProductFilterWithDescription.ItemDimTypeCode
		, ItemDimTypeDescription = ProductFilterWithDescription.ItemDimTypeDescription
		, ItemDim1Code = prItemVariant.ItemDim1Code
		, ItemDim1Description = ISNULL(cdItemDim1Desc.ItemDim1Description,SPACE(0))
		, ItemDim2Code = prItemVariant.ItemDim2Code
		, ItemDim2Description = SPACE(0)
			  
		 , VatRate = ISNULL(( SELECT	VatRate
							   FROM		cdVat WITH ( NOLOCK )
							   WHERE	cdVat.VatCode = cdItem.ItemTaxGrCode
							 ), SPACE(0))
		, Price1 = Isnull(ItemBasePrice.PurchasePrice ,SPACE(0))

		, Price2 = COALESCE(ProductValidPrices_ColorPSF.Price, ProductValidPrices_ProductPSF.Price, ItembasePrice.RetailSalePrice ,0) --Satış Fiyatı

		, Price3 = COALESCE(ProductValidPrices_ColorISF.Price, ProductValidPrices_ProductISF.Price, 0) --İndirimli Fiyat


		, InventoryQty = ISNULL((SELECT	SUM(InventoryQty1)
											FROM	ItemInventory AS Warehouse1Inv WITH ( NOLOCK )
                                            WHERE	Warehouse1Inv.ItemTypeCode = prItemVariant.ItemTypeCode
                                           			AND Warehouse1Inv.ItemCode = prItemVariant.ItemCode
                                           			AND Warehouse1Inv.ColorCode = prItemVariant.ColorCode
                                           			AND Warehouse1Inv.ItemDim1Code = prItemVariant.ItemDim1Code
													AND Warehouse1Inv.ItemDim2Code = prItemVariant.ItemDim2Code
                                           			AND Warehouse1Inv.WarehouseCode IN('D1','M1','M2','M3')),0)
								  -  ISNULL((SELECT SUM(RemainingOrderQty1)
											FROM  OrderStatus() 
											WHERE OrderStatus.ItemTypeCode = prItemVariant.ItemTypeCode
											      AND OrderStatus.ItemCode = prItemVariant.ItemCode
												  AND OrderStatus.ColorCode = prItemVariant.ColorCode
												  AND OrderStatus.ItemDim1Code = prItemVariant.ItemDim1Code
												  AND OrderStatus.ItemDim2Code = prItemVariant.ItemDim2Code
												  AND OrderStatus.WarehouseCode IN('D1','M1','M2','M3')),0)

		  , dbo.cdItem.UnitOfMeasureCode1
		  , Barcode = ISNULL(( SELECT	MAX(Barcode)
							   FROM		prItemBarcode WITH ( NOLOCK )
							   WHERE	prItemBarcode.BarcodeTypeCode IN ('B','Def')
										AND prItemBarcode.ItemTypeCode = prItemVariant.ItemTypeCode
										AND prItemBarcode.ItemCode = prItemVariant.ItemCode
										AND prItemBarcode.ColorCode = prItemVariant.ColorCode
										AND prItemBarcode.ItemDim1Code = prItemVariant.ItemDim1Code
										AND prItemBarcode.ItemDim2Code = prItemVariant.ItemDim2Code
							 ), SPACE(0))
		  
		  , ProductHierarchyID = cdItem.ProductHierarchyID
		  , ProductHierarchyLevelCode01
		  , ProductHierarchyLevel01
		  , ProductHierarchyLevelCode02
		  , ProductHierarchyLevel02
		  , ProductHierarchyLevelCode03
		  , ProductHierarchyLevel03
		  , ProductAtt01	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=1 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt01Desc
		  , ProductAtt02	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=2 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt02Desc
		  , ProductAtt03	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=3 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt03Desc
		  , ProductAtt04	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=4 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt04Desc
		  , ProductAtt05	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=5 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt05Desc
		  , ProductAtt06	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=6 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt06Desc
		  , ProductAtt07	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=7 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt07Desc
		  , ProductAtt08	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=8 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt08Desc
		  , ProductAtt09	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=9 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt09Desc
		  , ProductAtt10	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=10 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt10Desc
		  , ProductAtt11	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=11 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt11Desc
		  , ProductAtt12	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=12 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt12Desc
		  , ProductAtt13	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=13 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt13Desc
		  , ProductAtt14	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=14 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt14Desc
		  , ProductAtt15	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=15 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt15Desc
		  , ProductAtt16	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=16 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt16Desc
		  , ProductAtt17	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=17 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt17Desc
		  , ProductAtt18	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=18 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt18Desc
		  , ProductAtt19	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=19 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt19Desc
		  , ProductAtt20	= ISNULL((SELECT  AttributeTypeDescription FROM ItemAttributeType('TR') WHERE ItemTypeCode=1 AND AttributeTypeCode=20 AND IsBlocked=0 ) ,SPACE(0))
		  , ProductAtt20Desc	
		  , UseInternet = 	 ProductFilterWithDescription.UseInternet 	  

	FROM	cdItem WITH ( NOLOCK )
		LEFT OUTER JOIN prItemVariant WITH ( NOLOCK ) ON prItemVariant.ItemTypeCode = cdItem.ItemTypeCode
														AND prItemVariant.ItemCode = cdItem.ItemCode

		LEFT OUTER JOIN cdItemDim1Desc  WITH ( NOLOCK ) ON  cdItemDim1Desc.ItemDim1Code = prItemVariant.ItemDim1Code AND LangCode='TR'

		LEFT OUTER JOIN ProductFilterWithDescription ('TR') ON ProductFilterWithDescription.ProductTypeCode = prItemVariant.ItemTypeCode
														AND ProductFilterWithDescription.ProductCode = prItemVariant.ItemCode

		LEFT OUTER JOIN ItemBasePrice ('TR')  ON ItemBasePrice.ItemTypeCode = cdItem.ItemTypeCode AND ItemBasePrice.ItemCode = cdItem.ItemCode
	  												
--FİYAT 1 İÇİN (SATIŞ FİYATI)	
	LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W1'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.ItemDim2Code		= ProductValidPrices.ItemDim2Code
																			AND LastPrice.ItemDim3Code		= ProductValidPrices.ItemDim3Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
																			
							AND 	ProductValidPrices.ColorCode = SPACE(0)	
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_productPSF
			ON ProductValidPrices_productPSF.PriceGroupCode		= 'W1'
				AND ProductValidPrices_productPSF.ItemTypeCode		= cdItem.ItemTypeCode
				AND ProductValidPrices_productPSF.ItemCode			= cdItem.ItemCode
		
		LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W1'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)													
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_ColorPSF
			ON ProductValidPrices_ColorPSF.PriceGroupCode				= 'W1'
				AND ProductValidPrices_ColorPSF.ItemTypeCode			= prItemVariant.ItemTypeCode
				AND ProductValidPrices_ColorPSF.ItemCode				= prItemVariant.ItemCode				
				AND ProductValidPrices_ColorPSF.ColorCode				= prItemVariant.ColorCode
----FİYAT 1 İÇİN (SATIŞ FİYATI)	BİTİŞ		

--FİYAT 2 İÇİN (İNDİRİMLİ FİYATI)	
	LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W2'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.ItemDim2Code		= ProductValidPrices.ItemDim2Code
																			AND LastPrice.ItemDim3Code		= ProductValidPrices.ItemDim3Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
																			
							AND 	ProductValidPrices.ColorCode = SPACE(0)	
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_productISF
			ON ProductValidPrices_productISF.PriceGroupCode		= 'W2'
				AND ProductValidPrices_productISF.ItemTypeCode		= cdItem.ItemTypeCode
				AND ProductValidPrices_productISF.ItemCode			= cdItem.ItemCode
		
		LEFT OUTER JOIN (SELECT * FROM ProductValidPrices(GETDATE(), GETDATE())
							WHERE ProductValidPrices.PriceListLineID = (SELECT TOP 1 LastPrice.PriceListLineID 
																			FROM ProductValidPrices(GETDATE(), GETDATE()) LastPrice
																			WHERE LastPrice.PriceGroupCode	= 'W2'
																			AND LastPrice.ItemTypeCode		= ProductValidPrices.ItemTypeCode
																			AND LastPrice.ItemCode			= ProductValidPrices.ItemCode
																			AND LastPrice.ColorCode			= ProductValidPrices.ColorCode
																			AND LastPrice.ItemDim1Code		= ProductValidPrices.ItemDim1Code
																			AND LastPrice.PaymentPlanCode	= ''
																			ORDER BY PriceListDate) 
							AND 	ProductValidPrices.ItemDim1Code = SPACE(0)													
							AND 	ProductValidPrices.ItemDim2Code = SPACE(0)																	
							AND 	ProductValidPrices.ItemDim3Code = SPACE(0)	) AS	ProductValidPrices_ColorISF
			ON ProductValidPrices_ColorISF.PriceGroupCode				= 'W2'
				AND ProductValidPrices_ColorISF.ItemTypeCode			= prItemVariant.ItemTypeCode
				AND ProductValidPrices_ColorISF.ItemCode				= prItemVariant.ItemCode				
				AND ProductValidPrices_ColorISF.ColorCode				= prItemVariant.ColorCode
----FİYAT 2 İÇİN (İNDİRİMLİ FİYATI)	BİTİŞ	
	
	WHERE	cdItem.ItemTypeCode = 1
			AND cdItem.ItemCode <> SPACE(0)
			AND cdItem.UseStore=1
			AND prItemVariant.CreatedDate >=@CreatedDate
			

GO

